Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class BufferedReader

    java.lang.Object
      |
      +--java.io.Reader
            |
            +--java.io.BufferedReader

Direct Known Subclasses:
  LineNumberReader

public class BufferedReader
extends Reader

Read text from a character-input stream, buffering characters so as to provide for the efficient reading of characters, arrays, and lines.

The buffer size may be specified, or the default size may be used. The default is large enough for most purposes.

In general, each read request made of a Reader causes a corresponding read request to be made of the underlying character or byte stream. It is therefore advisable to wrap a BufferedReader around any Reader whose read() operations may be costly, such as FileReaders and InputStreamReaders. For example,

     BufferedReader in
       = new BufferedReader(new FileReader("foo.in"));

will buffer the input from the specified file. Without buffering, each invocation of read() or readLine() could cause bytes to be read from the file, converted into characters, and then returned, which can be very inefficient.

Programs that use DataInputStreams for textual input can be localized by replacing each DataInputStream with an appropriate BufferedReader.

Since:
  JDK1.1
See Also:
  `FileReader`, `InputStreamReader`

Fields inherited from class java.io.Reader
`lock`

Constructor Summary
`BufferedReader(Reader in)` Create a buffering character-input stream that uses a default-sized input buffer.
`BufferedReader(Reader in, int sz)` Create a buffering character-input stream that uses an input buffer of the specified size.

Method Summary
`void` | `close()` Close the stream.
`void` | `mark(int readAheadLimit)` Mark the present position in the stream.
`boolean` | `markSupported()` Tell whether this stream supports the mark() operation, which it does.
`int` | `read()` Read a single character.
`int` | `read(char[] cbuf, int off, int len)` Read characters into a portion of an array.
`String` | `readLine()` Read a line of text.
`boolean` | `ready()` Tell whether this stream is ready to be read.
`void` | `reset()` Reset the stream to the most recent mark.
`long` | `skip(long n)` Skip characters.

Methods inherited from class java.io.Reader
`read`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BufferedReader

    public BufferedReader(Reader in,
                          int sz)

  Create a buffering character-input stream that uses an input buffer of the specified size.
  Parameters:
    `in` - A Reader
    `sz` - Input-buffer size
  Throws:
    `IllegalArgumentException` - If sz is <= 0

### BufferedReader

    public BufferedReader(Reader in)

  Create a buffering character-input stream that uses a default-sized input buffer.
  Parameters:
    `in` - A Reader

Method Detail

### read

    public int read()
             throws IOException

  Read a single character.
  Overrides:
    `read` in class `Reader`
  Throws:
    `IOException` - If an I/O error occurs

### read

    public int read(char[] cbuf,
                    int off,
                    int len)
             throws IOException

  Read characters into a portion of an array.

  This method implements the general contract of the corresponding ``read`` method of the ``Reader`` class. As an additional convenience, it attempts to read as many characters as possible by repeatedly invoking the `read` method of the underlying stream. This iterated `read` continues until one of the following conditions becomes true:

  - The specified number of characters have been read,
  - The `read` method of the underlying stream returns `-1`, indicating end-of-file, or
  - The `ready` method of the underlying stream returns `false`, indicating that further input requests would block.
  If the first `read` on the underlying stream returns `-1` to indicate end-of-file then this method returns `-1`. Otherwise this method returns the number of characters actually read.

  Subclasses of this class are encouraged, but not required, to attempt to read as many characters as possible in the same fashion.

  Ordinarily this method takes characters from this stream's character buffer, filling it from the underlying stream as necessary. If, however, the buffer is empty, the mark is not valid, and the requested length is at least as large as the buffer, then this method will read characters directly from the underlying stream into the given array. Thus redundant `BufferedReader`s will not copy data unnecessarily.

  Overrides:
    `read` in class `Reader`
  Parameters:
    `cbuf` - Destination buffer
    `off` - Offset at which to start storing characters
    `len` - Maximum number of characters to read
  Returns:
    The number of characters read, or -1 if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### readLine

    public String readLine()
                    throws IOException

  Read a line of text. A line is considered to be terminated by any one of a line feed ('\n'), a carriage return ('\r'), or a carriage return followed immediately by a linefeed.
  Returns:
    A String containing the contents of the line, not including any line-termination characters, or null if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### skip

    public long skip(long n)
              throws IOException

  Skip characters.
  Overrides:
    `skip` in class `Reader`
  Parameters:
    `n` - The number of characters to skip
  Returns:
    The number of characters actually skipped
  Throws:
    `IllegalArgumentException` - If `n` is negative.
    `IOException` - If an I/O error occurs

### ready

    public boolean ready()
                  throws IOException

  Tell whether this stream is ready to be read. A buffered character stream is ready if the buffer is not empty, or if the underlying character stream is ready.
  Overrides:
    `ready` in class `Reader`
  Throws:
    `IOException` - If an I/O error occurs

### markSupported

    public boolean markSupported()

  Tell whether this stream supports the mark() operation, which it does.
  Overrides:
    `markSupported` in class `Reader`
  Following copied from class: `java.io.Reader`
  Returns:
    true if and only if this stream supports the mark operation.

### mark

    public void mark(int readAheadLimit)
              throws IOException

  Mark the present position in the stream. Subsequent calls to reset() will attempt to reposition the stream to this point.
  Overrides:
    `mark` in class `Reader`
  Parameters:
    `readAheadLimit` - Limit on the number of characters that may be read while still preserving the mark. After reading this many characters, attempting to reset the stream may fail. A limit value larger than the size of the input buffer will cause a new buffer to be allocated whose size is no smaller than limit. Therefore large values should be used with care.
  Throws:
    `IllegalArgumentException` - If readAheadLimit is < 0
    `IOException` - If an I/O error occurs

### reset

    public void reset()
               throws IOException

  Reset the stream to the most recent mark.
  Overrides:
    `reset` in class `Reader`
  Throws:
    `IOException` - If the stream has never been marked, or if the mark has been invalidated

### close

    public void close()
               throws IOException

  Close the stream.
  Overrides:
    `close` in class `Reader`
  Throws:
    `IOException` - If an I/O error occurs

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.